#pragma once
#include "DxLib.h"
#include "Collision.h"
#include "GameStatus.h"
#include "scrollManager.h"

struct sMapLayer
{
    int** mapData;                  //}bv`bv2z
    int mapXNum;                    //ɕł鐔
    int mapYNum;                    //cɕł鐔
};

//CSV}bvf[^
extern sMapLayer map;

class Back
{
public:
    //////////////////////////////////////////////
    // 萔`
    //////////////////////////////////////////////
    //^Cg
    int titleImg;                   //^Cg摜nh
    int resultImg;                  //Ug摜nhij
    int defeatImg;                  //Ug摜nhisj
    int goalImg;                    //S[摜nh
    int goalX = 0;                  //S[XW
    int goalY = 0;                  //S[XW
    int X, Y;                       //^CgX,YW
    //}bv`bv
    const int   mapChipSize = 30;   //}bv`bvTCY
    const int   chipImgXNum = 4 ;   //}bv摜
    const int   chipImgYNum = 1 ;   //}bv摜c

    int   mapChipImg[30];           //摜nhz

    //wi摜
    int back1;


    // 摜iCSVjǂݍ
    void Load();
    // 
    void Init();
    // }bv̕`
    void DrawMap(int scrollOffsetX, int scrollOffsetY, Scroll& scroll);
    // ㏈
    void Finelize();
    // }bvƏՓ˂Ă邩true/falseŕԂ
    bool mapHitCalc(sHitRect& checkRect, Collision& collision, Back& back);
    // CSVt@C̓ǂݍ(}bv[_[)
    bool LoadCsv    (sMapLayer& dst, const char* mapCSVFileName);
    // }bv̔jiJj
    void mapUnloader(sMapLayer& dst);
    // CSV}bv`
    void DrawCsv(sMapLayer& layer, int scrollOffsetX, int scrollOffsetY, Scroll& scroll);
    // ^Cg`
    void DrawTitle  ();
    // Ug`()
    void DrawResult ();
    // Ug`(s)
    void DrawDefeat();
    //S[tbO`
    void DrawGoal();
    //wi`ϐ
    void DrawBackAll();
    // }bvCfbNXʒuubNԍԂ
    unsigned char mapGetBlockType   (int ix, int iy);
    unsigned char mapGetBlockTypeXY (int x, int y);
};