#include "Player.h"

//-------------------------------------
//摜ǂݍ
//-------------------------------------
void Player::Load()
{
    //摜̓ǂݍ
    Normal = LoadDivGraph("data/player.png", animPatternNum * animTypeNum, animPatternNum, animTypeNum, imageSizeX, imageSizeY, playerImg);
}

//-------------------------------------
//RXgN^ij
//-------------------------------------
void Player::Init(Collision& collision)
{
    //W
    px = 200.0f;
    py = 740.0f;
    VX = 0.0f;
    VY = 0.0f;
    animTimer = 0.0f;
    jumpFlg = false;
    //蔻菉
    collision.initRect(playerHit, hitSizeX, hitSizeY);
    collision.initRect(playerFootCollider, hitSizeX - colliderOffset, 1);
    collision.initRect(playerHeadCollider, hitSizeX - colliderOffset, 1);

    //E猩ăZ^[ɂȂ悤ɌvZ
    drawOffsetX = (hitSizeX - imageSizeX) / 2;
    drawOffsetY = (hitSizeY - imageSizeY);

    onGround = false;
    hitHead = false;
    jumpTimer = jumpButtonAcceptTime;

    isJumpPush = false;
    prevJumpButton = false;
}

//-------------------------------------
//vC[XV
//-------------------------------------
void Player::Update(float deltaTime, Collision& collision, sHitRect playAreaRect)
{
    bool isMove = inputMove(deltaTime);

    //ʍEL͂ݏoĂȂ
    // ㉺͌ɗ肷悤ɂ邽߃`FbNB
    if (px < playAreaRect.worldLX)
    {
        px = playAreaRect.worldLX + 2;
    }   
    if (px + hitSizeX > playAreaRect.worldRX)
    {
        px = playAreaRect.worldRX - hitSizeX;
        VX = 0;
    }

    //ڒnĂH
    if (onGround)
    {
        jumpFlg = false;
        VY = 0.0f;
        jumpTimer = jumpButtonAcceptTime;
    }
    else
    {
        jumpFlg = true;
    }

    //ɓH
    if (onGround)
    {
        VY = hitHeadBreakRatio * VY;
    }

    //蔻ʒuXV
    collision.updateWorldRect(playerHit, px, py);
    collision.updateWorldRect(playerFootCollider, px + colliderOffset / 2, py + playerHit.h);
    collision.updateWorldRect(playerHeadCollider, px + colliderOffset / 2, py - playerHeadCollider.h);

    ////////////////////////////
    // Aj[VvZ
    ////////////////////////////
    if (isMove)
    {
        // animTimer ŎԌo߂𑪂A 1.0 / animationFPS ̃Aj[Vp^[ɐił悢b
        // Ȃ玟̃R}ɐi߂
        animTimer += deltaTime;
        if (animTimer > 1.0f / animationFPS)
        {
            // ^C}[0 ̃p^[ɐi߂邪AanimPetternNum𒴂Ȃ悤Ƀ[v
            animTimer = 0.0f;
            animNowPattern++;
            animNowPattern %= animPatternNum; // ]Ȃ̂ 0,1,2̂ꂩɂȂ
        }
    }
    else
    {
        animNowPattern = 1; // Î~͑낦p^[ɋ
    }

    // ŏIIȓYvZ 
    // Y = ̃p^[̃R} + Aj[V * P̃Aj[Ṽp^[
    animNowIndex = animNowPattern + animNowType * animPatternNum;
}

//-------------------------------------
//vC[`
//-------------------------------------
void Player::Draw(int scrollOffsetX, int scrollOffsetY, Scroll& scroll)
{
    scrollOffsetX = scroll.scrollGetDrawOffsetX();

    DrawGraph(static_cast<int>(px) + drawOffsetX - scrollOffsetX,
              static_cast<int>(py) + drawOffsetY - scrollOffsetY, playerImg[animNowIndex], TRUE);
}

//-------------------------------------
//fXgN^i㏈j
//-------------------------------------
void Player::Finalize()
{
    if (playerImg[0] != -1)
    {
        for (int i = 0; i < animPatternNum * animTypeNum; i++)
        {
            DeleteGraph(playerImg[i]);
        }
    }
    DeleteGraph(Normal);
}

sHitRect Player::getPlayerHitRect()
{
    return playerHit;
}

void Player::playerfixColPosition(sHitRect& hitRect)
{
    //E̕ǂɓ̂ŉxO
    if (px != hitRect.worldLX)
    {
        VX = 0.0f;
    }
    //㉺̕ǂɓ̂ŏcx0
    if (py != hitRect.worldLY)
    {
        VY = 0.0f;
    }

    px = hitRect.worldLX;
    py = hitRect.worldLY;

    playerHit = hitRect;
}

void Player::playerSetGroundFlg(bool groundFlg)
{
    onGround = groundFlg;
}

void Player::playerSetHeadHitFlg(bool headHitFlg)
{
    hitHead = headHitFlg;
}

sHitRect Player::playerGetGroundCollider()
{
    return playerFootCollider;
}

sHitRect Player::playerGetHeadCollider()
{
    return playerHeadCollider;
}

bool Player::inputMove(float deltaTime)
{
    ///////////////////////////////////////////
    // ͏
    ///////////////////////////////////////////
    // Wv{^uԂH
    if (CheckHitKey(KEY_INPUT_SPACE))
    {
        if (!prevJumpButton)
        {
            isJumpPush = true;
        }
        else
        {
            isJumpPush = false;
        }
        prevJumpButton = true;
    }
    else
    {
        prevJumpButton = false;
    }


    bool isMove = false;
    if (CheckHitKey(KEY_INPUT_LEFT))
    {
        if (!jumpFlg)
        {
            // ]
            if (VX > 0.0f)
            {
                VX *= brakeRatio;
            }
            // nx
            VX += -moveAccell * deltaTime;
        }
        else
        {
            //󒆉x
            VX += -moveAccell * inAirMoveAccelRatio * deltaTime;
        }
        //xNbv
        if (VX < -maxMoveSpeed)
        {
            VX = -maxMoveSpeed;
        }
        animNowType = Normal;
        isMove = true;
    }
    if (CheckHitKey(KEY_INPUT_RIGHT))
    {
        if (!jumpFlg)
        {
            // ]
            if (VX < 0.0f)
            {
                VX *= brakeRatio;
            }
            // nx
            VX += +moveAccell * deltaTime;
        }
        else
        {
            // 󒆉x
            VX += +moveAccell * inAirMoveAccelRatio * deltaTime;
        }

        // xNbv
        if (VX > maxMoveSpeed)
        {
            VX = +maxMoveSpeed;
        }
        animNowType = Normal;
        isMove = true;
    }

    //WvL[ꂽuԂłWv\H
    if (isJumpPush && !jumpFlg && jumpTimer > 0.0f)
    {
        VY -= jumpInitialVelocity;
        jumpFlg = true;
        onGround = false;
    }

    // Wvŏ㏸^C}[ԂȂ㏸
    if (prevJumpButton && jumpTimer > 0.0f)
    {
        VY -= jumpUpSpeed * deltaTime;
    }

    // WvȂd͂𔭐
    if (jumpFlg)
    {
        jumpTimer -= deltaTime;
        VY += gravity * deltaTime;
    }

    // L[͂ȂƂnł̌
    if (!isMove && !jumpFlg)
    {
        VY *= frictionRatio;
    }
    // x}
    if (VY * deltaTime > maxFallSpeed)
    {
        VY = maxFallSpeed;
    }
    // ʒuXV
    px += VX;
    py += VY;

    return isMove;
}