#pragma once
#include "DxLib.h"

/// <summary>
/// 蔻`
/// </summary>
struct sHitRect
{
	float w;		// `sNZ
	float h;        // `sNZ
	float worldLX;  // XW
	float worldLY;  // YW
	float worldRX;  // EXW
	float worldRY;  // EYW
};

class Collision
{
public:
	// ubNǏ
	#define BLOCK_LEFT  0x01    // 0001
	#define BLOCK_RIGHT 0x02    // 0010
	#define BLOCK_UP    0x04    // 0100
	#define BLOCK_DOWN  0x08    // 1000
	
	/// <summary>
	/// ubNǏ^
	/// </summary>
	typedef unsigned char BlockInfo;

	/// <summary>
	/// 蔻菉
	/// </summary>
	/// <param name="dstRect">XV蔻ϐ</param>
	/// <param name="w">蔻̕</param>
	/// <param name="h">蔻荂</param>
	void initRect(sHitRect& dstRect, float w, float h);

	/// <summary>
	/// 蔻̈ړXV
	/// </summary>
	/// <param name="dstRect">XV蔻ϐ</param>
	/// <param name="x">蔻荶xW</param>
	/// <param name="y">蔻荶yW</param>
	void updateWorldRect(sHitRect& dstRect, float x, float y);

	/// <summary>
	/// ̋`Փ˂Ԃ
	/// </summary>
	/// <param name="rect1">`1</param>
	/// <param name="rect2">`2</param>
	/// <returns>`̓Փ˂true/falseŕԂ</returns>
	bool isHitRect(const sHitRect& rect1, const sHitRect& rect2);

	/// <summary>
	/// 2̋`̏Փ˂߂荞ݗʂvZAmobableRecẗʒuXV
	/// </summary>
	/// <param name="movableRect">ړ\`</param>
	/// <param name="staticRect">Î~`iȂubNȂǁj</param>
	/// <param name="blockInfo">ubN</param>
	void calcFixHitRectPosition(sHitRect& movableRect, const sHitRect& staticRect, BlockInfo blockInfo);
};