#pragma once
#include "Collision.h"
#include "DxLib.h"
#include "scrollManager.h"

class Player
{
public:
    //摜
    static const int animPatternNum = 8;           // Aj[Ṽp^[
    static const int animTypeNum = 1;              // Aj[V̎
    
    //Wv
    const float animationFPS            = 8.0f  ;   // b8R}̃Aj[V
    const float moveSpeed               = 300.0f;   // ړx
    const float maxMoveSpeed            = 350.0f;   // ő剡ړx
    const float moveAccell              = 2.5f;     // ړx
    const float frictionRatio           = 0.01f;     // CW
    const float brakeRatio              = 0.1f;     // isɑ΂ē͋tɓꂽƂ̃u[LW
    const float inAirMoveAccelRatio     = 3.0f;     // 󒆉ړ
    const float jumpInitialVelocity     = 15.0f  ;  // Wvx
    const float jumpUpSpeed             = 10.0f ;   // ㏸Xs[h
    const float hitHeadBreakRatio       = -0.1f ;   // Փˎ̌

    const int imageSizeX = 50;                     // 摜TCY
    const int imageSizeY = 50;                     // 摜cTCY
    const int hitSizeX   = 50;                     // 蔻XTCY
    const int hitSizeY   = 50;                     // 蔻YTCY

    const float gravity                 = 25.0f ;   // d
    const float maxFallSpeed            = 200.0f;   // ő嗎Xs[h
    const int colliderOffset            = 10     ;   // RC_[炵
    const float jumpButtonAcceptTime    = 0.95f ;   // Wv{^t

    //W
    float px;                                       // vC[XW
    float py;                                       // vC[YW
    float VX;                                       // vC[Xړx
    float VY;                                       // vC[Yړx
    float playerEndposition;                        // vC[̏I[ʒu
    float animTimer;                                // Aj[V^C}[
    int animNowType;                                // ݂̃Aj
    int animNowPattern;                             // ݂̃Ajp^[
    int animNowIndex;                               // Aj[V摜z̓Y 0`10܂ł̐l
    int drawOffsetX;                                // 炵
    int drawOffsetY;                                // c炵

    bool jumpFlg;                                   // WvtO
    bool onGround;                                  // nʂɂĂ邩
    bool hitHead;                                   // Ԃ
    float jumpTimer;

    int playerImg[animPatternNum * animTypeNum]; // vC[̉摜nh
    int Normal;

    sHitRect playerHit;           // vC[蔻
    sHitRect playerFootCollider;  // ڒnRC_[
    sHitRect playerHeadCollider;  // RC_[

    bool prevJumpButton;          // Õt[ŃWv{^ĂH
    bool isJumpPush;              // Wv{^ꂽuԂH

    bool inputMove  (float deltaTime);

    /// <summary>
    /// 摜ǂݍ
    /// </summary>
    void Load();

    /// <summary>
    /// vC[
    /// </summary>
    void Init       (Collision& collision);
   
    /// <summary>
    /// vC[XV
    /// </summary>
    /// <param name="deltaTime">1t[̏</param>
    /// <param name="playAreaRect">vCʂ̃[hW`BscreenManagergetPlayArea()֐̖߂lgp</param>
    void Update(float deltaTime, Collision& collision, sHitRect playAreaRect);

    /// <summary>
    /// vC[`
    /// </summary>
    /// <param name="scrollOffsetX">XN[ړX</param>
    /// <param name="scrollOffsetY">XN[ړY</param>
    void Draw(int scrollOffsetX, int scrollOffsetY, Scroll& scroll);

    /// <summary>
    /// vC[n
    /// </summary>
    void Finalize   ();
   
    /// <summary>
    /// 蔻`vC[ʒuC
    /// </summary>
    /// <param name="hitRect">蔻`</param>
    void playerfixColPosition   (sHitRect& hitRect);

    /// <summary>
    /// vC[̓蔻`Ԃ
    /// </summary>
    /// <returns>vC[̓蔻`</returns>
    sHitRect getPlayerHitRect();

    /// <summary>
    /// nʂɗĂ邩H
    /// </summary>
    /// <param name="groundFlg">̓蔻茋</param>
    void playerSetGroundFlg     (bool groundFlg);
    
    /// <summary>
    /// vC[̑RC_[̃Qbg
    /// </summary>
    /// <returns>RC_[̋`</returns>
    sHitRect playerGetGroundCollider();

    /// <summary>
    /// ǂɂԂ
    /// </summary>
    /// <param name="headHitFlg">̓蔻茋</param>
    void playerSetHeadHitFlg(bool headHitFlg);

    /// <summary>
    /// vC[̓RC_[̃Qbg
    /// </summary>
    /// <returns>RC_[̋`</returns>
    sHitRect playerGetHeadCollider();
};