#include "scrollManager.h"
#include "DxLib.h"
#pragma warning (disable:4996)

void Scroll::scrollManagerInit(int screenwidth, int screenheight, const sHitRect& worldRect, Collision& collision)
{	
	screenWidth  = screenwidth ;					// XN[
	screenHeight = screenheight;					// XN[

	scrollXMax = worldRect.worldRX - screenWidth;	// őEXN[

	scrollX = 0;
	collision.initRect(worldScreenRect, static_cast<float>(screenWidth), static_cast<float>(screenHeight));
}

void Scroll::scrollUpdate(const sHitRect& playerRect, float deltaTime, Collision& collision)
{
	scrollX += scrollSpeed;

	if (scrollX > scrollXMax)
	{
		scrollX = scrollXMax;
	}

	// XN[̃[hWXV
	collision.updateWorldRect(worldScreenRect, scrollX, 0.0f);
}

int Scroll::scrollGetDrawOffsetX()
{
	return static_cast<int>(scrollX);
}

sHitRect Scroll::scrollGetWorldScreenRect()
{
	return worldScreenRect;
}

sHitRect Scroll::getPlayArea()
{
	// ݂̃XN[̃[hWvZ
	// 4̃[hW`
	sHitRect rect;
	rect.worldLX = scrollX;
	rect.worldRX = scrollX + screenWidth;

	return rect;
}
